-- Ŀ
--  E-Term.EX V1.01 by PJB Systems                                            
-- 

include Serial.E

integer Port,Baud,Parity,Data,Stop,rx,tx,rcnt
sequence rbuff  rbuff = {}
sequence BPDS

Port = 4 -- Change this if you like to 1, 2, 3 or 4

SetPortBPDS(Port,2400,0,8,1) -- You can change the baud,parity,data & stop
--                       Stop bit 1 or 2
--                      Data bits 5,6,7 & 8
--                     Parity 0 = None, 1 = Even, -1 = Odd
--               Baud rate 75 ~ 115200
--           Port COM1: to COM4:

for p = 1 to 4 do
  BPDS   = GetPortBPDS(p)
  Baud   = BPDS[1] -- 75 ~ 115200
  Parity = BPDS[2] -- 0, 1, -1
  Data   = BPDS[3] -- 5,6,7 & 8
  Stop   = BPDS[4] -- 1 or 2
  printf(1,"COM%d: Baud=%d Parity=%d Data=%d Stop=%d\n",
    {p,Baud,Parity,Data,Stop})
end for


puts(1,"To dial     - ATDT number\n")
puts(1,"To hangup   - ATH\n")
puts(1,"To Answer   - ATA\n")
puts(1,"To get info - ATI4\n")
puts(1,"Press ESC to quit\n")

rcnt = 0
tx = 0
while tx != 27 do
  rx = GetSerialByte(Port)
  if rx > 0 then -- Catch data as it comes in
    rbuff = rbuff & rx -- Store in buffer
    rcnt = 20 -- Ensure no other tasks run while data comes in
  else
    rcnt = rcnt - 1
  end if

  if rcnt < 1 then -- OK to do task
    rcnt = 0
    tx = get_key() -- Get key presses
    if tx > 0 then -- Send key
      SendSerialByte(Port,tx)
    end if
    
    if length(rbuff) > 0 then
      printf(1,"%s",{rbuff})
      rbuff = {}
    end if
  end if
end while 


